base-compat-0.8.2: A compatibility layer for base

Safe Haskell | Safe
Language | Haskell98

Control.Monad.Compat

Synopsis

- class Applicative m => Monad m where
  - (>>=) :: m a -> (a -> m b) -> m b
  - (>>) :: m a -> m b -> m b
  - return :: a -> m a
  - fail :: String -> m a
- class (Alternative m, Monad m) => MonadPlus m where
  - mzero :: m a
  - mplus :: m a -> m a -> m a

# Documentation

class Applicative m => Monad m where

The `Monad` class defines the basic operations over a monad, a concept from a branch of mathematics known as category theory. From the perspective of a Haskell programmer, however, it is best to think of a monad as an abstract datatype of actions. Haskell's `do` expressions provide a convenient syntax for writing monadic expressions.

Instances of `Monad` should satisfy the following laws:

-     return a >>= k  =  k a

-     m >>= return  =  m

-     m >>= (x -> k x >>= h)  =  (m >>= k) >>= h

Furthermore, the `Monad` and `Applicative` operations should relate as follows:

-     pure = return

-     (<*>) = ap

The above laws imply:

-     fmap f xs  =  xs >>= return . f

-     (>>) = (*>)

and that `pure` and (`<*>`) satisfy the applicative functor laws.

The instances of `Monad` for lists, `Maybe` and `IO` defined in the Prelude satisfy these laws.

Minimal complete definition

(>>=)

Methods

(>>=) :: m a -> (a -> m b) -> m b infixl 1

Sequentially compose two actions, passing any value produced by the first as an argument to the second.

(>>) :: m a -> m b -> m b infixl 1

Sequentially compose two actions, discarding any value produced by the first, like sequencing operators (such as the semicolon) in imperative languages.

return :: a -> m a

Inject a value into the monadic type.

fail :: String -> m a

Fail with a message. This operation is not part of the mathematical definition of a monad, but is invoked on pattern-match failure in a `do` expression.

Instances

Monad [] |
Monad IO |
Monad P |
Monad First |
Monad Last |
Monad ReadPrec |
Monad ReadP |
Monad Maybe |
Monad ((->) r) |
Monad (Either e) |
Monad (Proxy *) |
Monad f => Monad (Alt * f) |

class (Alternative m, Monad m) => MonadPlus m where

Monads that also support choice and failure.

Minimal complete definition

Nothing

Methods

mzero :: m a

the identity of `mplus`. It should also satisfy the equations

    mzero >>= f  =  mzero
    v >> mzero   =  mzero

mplus :: m a -> m a -> m a

an associative operation

Instances

MonadPlus [] |
MonadPlus P |
MonadPlus ReadPrec |
MonadPlus ReadP |
MonadPlus Maybe |
MonadPlus f => MonadPlus (Alt * f) |